<script setup>
    const config = useRuntimeConfig()

    import { ExistingHolder } from '~/adapters/holder.js';
    import { date_manager } from '~/adapters/date_manager.js';
    import { holder_manager } from '~/adapters/holder_manager.js';
    import { useClickOutsideEventListener } from '~/composables/graphics.js';

    // Data fetching
    const { data: locations, pending } = await useFetch(`${config.public.apiUrl}/locations-short`);

    // Emit data
    const emit = defineEmits(['close']);
    
    const tailleElement=30;

    onMounted(() => {
        useClickOutsideEventListener("form_locations", () => {emit("close", true)});
    });

    function registerLocation(location) {
        date_manager.setLocation(new ExistingHolder(false, true, location.name, location.uid));
        emit('close', true);
    }

</script>

<template>
    <div class="w-full flex flex-col space-y-2 bg-white shadow-las">
        <!-- Locations search list -->
        <FormSearchList
            :list=locations
            :tailleElement="tailleElement"
            :selected=holder_manager.getLocationNameList() 
            @add="(element) => registerLocation(element)"
        />
        <!-- Add new location -->
        <div class="flex flex-col py-4 space-y-2 text-center">
            <span class="text-center">Tu ne trouves pas ton lieu ?</span>
            <ButtonLink :link-text="'Ajouter lieu'" url="/holder?type=location"/>
        </div>
    </div>
</template>